<template>
	<div class="FieldsViewGroupFilter">
		<div class="FieldsViewGroupFilter-header">
			<h4>Filter by Group</h4>
			<template v-if="!useDesktopLayout">
				<v-spacer />
				<button class="FieldsViewGroupFilter-clear primary--text" @click="clearFilter">Clear filter</button>
			</template>
		</div>
		<v-divider />
		<p v-if="groupTree.length === 0">You are not a member of any groups, yet.</p>
		<v-treeview
			v-else
			:class="treeViewClass"
			:items="groupTree"
			:open="openedGroupIds"
			@update:open="handleOpenChange"
			dense
		>
			<template v-slot:label="{ item }">
				<v-checkbox
					:label="item.name"
					:value="item.id"
					:input-value="item.id"
					:true-value="item.id"
					:false-value="item.id"
					:value-comparator="isChecked"
					:ripple="false"
					@change="toggleCheck"
					dense
				/>
			</template>
		</v-treeview>
		<template v-if="useDesktopLayout">
			<v-divider />
			<div class="FieldsViewGroupFilter-footer">
				<button class="FieldsViewGroupFilter-clear primary--text" @click="clearFilter">Clear filter</button>
				<button class="FieldsViewGroupFilter-ok primary--text" @click="$emit('ok')">OK</button>
			</div>
		</template>
	</div>
</template>

<script lang="ts">
import { computed, defineComponent } from '@vue/composition-api';
import { useFieldsView } from '@/store/modules/fieldsView';
import { useGroups } from '@/store/modules/group';

export default defineComponent({
	emits: ['ok'],
	props: {
		useDesktopLayout: {
			type: Boolean,
			default: false,
		},
	},
	setup(_, { root }) {
		const { groupTree } = useGroups(root.$store);
		const { groupFilter, setGroupFilter } = useFieldsView(root.$store);
		const openedGroupIds = computed(() => root.$store.getters['fieldsView/getOpenedGroupIds']);

		const isChecked = (id: string) => groupFilter.value.includes(id);

		const treeViewClass = computed<string>(() => {
			const childrenCount = groupTree.value.reduce((prev, cur) => prev + cur.children.length, 0);
			return childrenCount === 0 ? 'no-children' : '';
		});

		const handleOpenChange = (value: string[]) => {
			root.$store.dispatch('fieldsView/setOpenedGroupIds', value);
		};

		const toggleCheck = (id: string) => {
			setGroupFilter(id);
		};

		const clearFilter = () => {
			// Uncheck all nodes
			root.$store.dispatch('fieldsView/clearGroupFilter');
			// Collapse group tree
			root.$store.dispatch('fieldsView/setOpenedGroupIds', []);
		};

		return {
			treeViewClass,
			groupTree,
			openedGroupIds,
			isChecked,
			toggleCheck,
			handleOpenChange,
			clearFilter,
		};
	},
});
</script>

<style lang="scss">
.FieldsViewGroupFilter {
	padding: 6px 8px;

	.FieldsViewGroupFilter-header {
		display: flex;
	}

	.FieldsViewGroupFilter-footer {
		display: flex;
		justify-content: space-between;
	}

	.v-divider {
		margin: 4px 0 8px 0;
	}

	.v-messages {
		display: none;
	}

	.v-treeview {
		&.no-children .v-treeview-node {
			.v-treeview-node__root {
				padding: 0;
			}
			.v-treeview-node__level {
				display: none;
			}
		}

		.v-treeview-node__label .v-input--selection-controls.v-input--checkbox {
			margin: 0;
			padding-top: 4px;
		}
	}
}
</style>
